#!/usr/bin/python
# Copyright 2016 CERN and GSI
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import iecommon
import time

#=========================================================================
# FESA .cproject file
#=========================================================================

cproject = """<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<?fileVersion 4.0.0?><cproject storage_type_id="org.eclipse.cdt.core.XmlProjectDescriptionStorage">
	<storageModule moduleId="org.eclipse.cdt.core.settings">
		<cconfiguration id="cern.fesa.plugin.build.configuration.537108490">
			<storageModule buildSystemId="org.eclipse.cdt.managedbuilder.core.configurationDataProvider" id="cern.fesa.plugin.build.configuration.537108490" moduleId="org.eclipse.cdt.core.settings" name="FESA Make Build">
				<externalSettings/>
				<extensions>
					<extension id="org.eclipse.cdt.core.GASErrorParser" point="org.eclipse.cdt.core.ErrorParser"/>
					<extension id="org.eclipse.cdt.core.GmakeErrorParser" point="org.eclipse.cdt.core.ErrorParser"/>
					<extension id="org.eclipse.cdt.core.GLDErrorParser" point="org.eclipse.cdt.core.ErrorParser"/>
					<extension id="org.eclipse.cdt.core.CWDLocator" point="org.eclipse.cdt.core.ErrorParser"/>
					<extension id="org.eclipse.cdt.core.GCCErrorParser" point="org.eclipse.cdt.core.ErrorParser"/>
				</extensions>
			</storageModule>
			<storageModule moduleId="cdtBuildSystem" version="4.0.0">
				<configuration buildProperties="" description="" id="cern.fesa.plugin.build.configuration.537108490" name="FESA Make Build" parent="cern.fesa.plugin.build.configuration">
					<folderInfo id="cern.fesa.plugin.build.configuration.537108490." name="/" resourcePath="">
						<toolChain id="cern.fesa.plugin.build.toolchain.1156032800" name="FESA Toolchain" superClass="cern.fesa.plugin.build.toolchain">
							<targetPlatform id="cern.fesa.plugin.build.targetplatform.67227612" isAbstract="false" superClass="cern.fesa.plugin.build.targetplatform"/>
							<builder id="cern.fesa.plugin.build.builder.1302129891" name="Gnu Make Builder.FESA Make Build" superClass="cern.fesa.plugin.build.builder"/>
							<tool id="cern.fesa.plugin.build.archiver.1068962328" name="GCC Archiver" superClass="cern.fesa.plugin.build.archiver"/>
							<tool id="cern.fesa.plugin.build.compiler.648804671" name="GCC C++ Compiler" superClass="cern.fesa.plugin.build.compiler">
								<option id="gnu.cpp.compiler.option.include.paths.12841593" name="Include paths (-I)" superClass="gnu.cpp.compiler.option.include.paths" valueType="includePath">
								</option>
								<inputType id="cdt.managedbuild.tool.gnu.cpp.compiler.input.2129597065" superClass="cdt.managedbuild.tool.gnu.cpp.compiler.input"/>
							</tool>
							<tool id="cdt.managedbuild.tool.gnu.c.compiler.base.662860517" name="GCC C Compiler" superClass="cdt.managedbuild.tool.gnu.c.compiler.base">
								<inputType id="cdt.managedbuild.tool.gnu.c.compiler.input.1388561052" superClass="cdt.managedbuild.tool.gnu.c.compiler.input"/>
							</tool>
							<tool id="cdt.managedbuild.tool.gnu.c.linker.base.365658250" name="GCC C Linker" superClass="cdt.managedbuild.tool.gnu.c.linker.base"/>
							<tool id="cern.fesa.plugin.build.linker.884627432" name="GCC C++ Linker" superClass="cern.fesa.plugin.build.linker">
								<inputType id="cdt.managedbuild.tool.gnu.cpp.linker.input.2024588043" superClass="cdt.managedbuild.tool.gnu.cpp.linker.input">
									<additionalInput kind="additionalinputdependency" paths="$(USER_OBJS)"/>
									<additionalInput kind="additionalinput" paths="$(LIBS)"/>
								</inputType>
							</tool>
							<tool id="cern.fesa.plugin.build.assembler.838409637" name="GCC Assembler" superClass="cern.fesa.plugin.build.assembler">
								<inputType id="cdt.managedbuild.tool.gnu.assembler.input.1405521367" superClass="cdt.managedbuild.tool.gnu.assembler.input"/>
							</tool>
						</toolChain>
					</folderInfo>
				</configuration>
			</storageModule>
			<storageModule moduleId="org.eclipse.cdt.core.externalSettings"/>
		</cconfiguration>
	</storageModule>
	<storageModule moduleId="cdtBuildSystem" version="4.0.0">
		<project id="" name=""/>
	</storageModule>
	<storageModule moduleId="org.eclipse.cdt.core.LanguageSettingsProviders"/>
	<storageModule moduleId="org.eclipse.cdt.make.core.buildtargets">
		<buildTargets>
			<target name="clean" path="" targetID="org.eclipse.cdt.build.MakeTargetBuilder">
				<buildCommand>make</buildCommand>
				<buildArguments/>
				<buildTarget>clean</buildTarget>
				<stopOnError>true</stopOnError>
				<useDefaultCommand>true</useDefaultCommand>
				<runAllBuilders>true</runAllBuilders>
			</target>
			<target name="all x86_64" path="" targetID="org.eclipse.cdt.build.MakeTargetBuilder">
				<buildCommand>make</buildCommand>
				<buildArguments/>
				<buildTarget>-j16 CPU=x86_64 </buildTarget>
				<stopOnError>true</stopOnError>
				<useDefaultCommand>true</useDefaultCommand>
				<runAllBuilders>true</runAllBuilders>
			</target>
		</buildTargets>
	</storageModule>
	<storageModule moduleId="scannerConfiguration"/>
</cproject>
"""

#=========================================================================
# H Source template (.h file)
#=========================================================================
hTop = """/*
 * %s.h
 *
 * Generated by SILECS framework tools 
 */

#ifndef %s_%s_H_
#define %s_%s_H_

#include <SilecsService.h>
#include <fesa-core/Synchronization/MultiplexingContext.h>
#include <%s/GeneratedCode/ServiceLocator.h>
    """

hTopBlock = """#include <%s/Server/%s.h>
    """

hTop2 = """
namespace %s
{

    /*---------------------------------------------------------------------------------------------------------
     * SETUP
     *---------------------------------------------------------------------------------------------------------
     *  Setup the SILECS service by calling the setup() method from the RTDeviceClass::specificInit()
     *  Stop and cleanup the SILECS service by calling the cleanup() method if needed (eg.: from ~RTDeviceClass())
     *
     *  In order to make use of the different blocks, defined in the silecsdesign, please make use of the static, block related variables of the class, defined on the bottom of this file !
     * --------------------------------------------------------------------------------------------------------
     */

    /*---------------------------------------------------------------------------------------------------------
     * COMMUNICATION
     *---------------------------------------------------------------------------------------------------------
     * General methods to synchronize the FESA fields and related PLC registers of the FESA server with or without
     * PLC side synchronization (send/recv) if requested. Each action is done for one particular block.
     * In case of BLOCK_MODE configuration (see SILECS doc.), the transaction is optimal with the following
     * 'AllDevices' and 'PLCDevices' methods.
     * Each method can be called in the appropriate server-action (set) and rt-action (get)
     *
     * getAllDevices  : [receive all devices of all connected PLCs +] update FESA fields with related SILECS registers
     * setAllDevices  : update SILECS registers with related FESA fields [+ send block to all connected PLCs]
     * getPLCDevices  : [receive all devices of one PLC +] update FESA fields with related SILECS registers
     * setPLCDevices  : update SILECS registers with related FESA fields [+ send block to the PLC]
     * getSomeDevices : [receive each device of the device-collection +] update FESA fields with related SILECS registers
     * setSomeDevices : update SILECS registers with related FESA fields [+ send block to each device of the device-collection]
     * getOneDevice   : [receive block of one PLC device +] update FESA fields with related SILECS registers
     * setOneDevice   : update SILECS registers with related FESA fields [+ send block to the PLC device]
     *
     * --------------------------------------------------------------------------------------------------------
     */

    class Abstract%s
    {
        public:
            static inline Silecs::Service* theService()  { return pService_; }
            static inline Silecs::Cluster* theCluster()  { return pCluster_; }
            inline std::string& getBlockName()          { return blockName_; }

            static void setup(const ServiceLocator* serviceLocator);
            static void cleanup();
            static void setPLCSlaveRegisters(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator);
            static void getPLCMasterRegisters(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator);

            Abstract%s(std::string blockName);
            virtual ~Abstract%s();

            void getAllDevices(const ServiceLocator* serviceLocator, const bool recvNow, MultiplexingContext* pContext);
            void getPLCDevices(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator, const bool recvNow, MultiplexingContext* pContext);
            void getSomeDevices(std::vector<Device*> deviceCol, const bool recvNow, MultiplexingContext* pContext);
            virtual void getOneDevice(Device* pDevice, const bool recvNow, MultiplexingContext* pContext);

            void setAllDevices(const ServiceLocator* serviceLocator, const bool sendNow, MultiplexingContext* pContext);
            void setPLCDevices(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator, const bool sendNow, MultiplexingContext* pContext);
            void setSomeDevices(std::vector<Device*> deviceCol, const bool sendNow, MultiplexingContext* pContext);
            virtual void setOneDevice(Device* pDevice, const bool sendNow, MultiplexingContext* pContext);

        protected:

            static Silecs::Service* pService_;
            static Silecs::Cluster* pCluster_;
            static bool isInitialized_;

            // Name of the silecs-block which is addressed
            std::string blockName_;

            // not copyable object
            Abstract%s(const Abstract%s&);
            Abstract%s& operator=(const Abstract%s&);
    };

    // -------------------------------------------------------------------------------------------------
    #define BLOCK_RO( name )\t\\
    class name##_Type : public Abstract%s\t\\
    {\t\\
        public:\t\\
            name##_Type(std::string name);\t\\
            ~name##_Type();\t\\
            void getOneDevice(Device* pDevice, const bool transmitNow, MultiplexingContext* pContext);\t\\
    }


    #define BLOCK_WO( name )\t\\
    class name##_Type : public Abstract%s\t\\
    {\t\\
        public:\t\\
            name##_Type(std::string name);\t\\
            ~name##_Type();\t\\
        void setOneDevice(Device* pDevice, const bool transmitNow, MultiplexingContext* pContext);\t\\
        void setOneDevice(Device* pDevice, name##PropertyData& data, const bool transmitNow, MultiplexingContext* pContext);\t\\
    }

    #define BLOCK_RW( name )\t\\
    class name##_Type : public Abstract%s\t\\
    {\t\\
        public:\t\\
            name##_Type(std::string name);\t\\
            ~name##_Type();\t\\
            void getOneDevice(Device* pDevice, const bool transmitNow, MultiplexingContext* pContext);\t\\
            void setOneDevice(Device* pDevice, const bool transmitNow, MultiplexingContext* pContext);\t\\
            void setOneDevice(Device* pDevice, name##PropertyData& data, const bool transmitNow, MultiplexingContext* pContext);\t\\
    }
    
    """

hBlock = """BLOCK_%s( %s );
    """

hBottom = """
    /*---------------------------------------------------------------------------------------------------------
     * INTERFACE
     *---------------------------------------------------------------------------------------------------------
     * This is the public interface used from the FESA code to access the PLC service.
     */
    class %s
    {
        public:
            static inline Silecs::Service* theService()  { return Abstract%s::theService(); }
            static inline Silecs::Cluster* theCluster()  { return Abstract%s::theCluster(); }
            static void setup(const ServiceLocator* serviceLocator) { Abstract%s::setup(serviceLocator); }
            static void cleanup() { Abstract%s::cleanup(); }

    """

hDeclBlocks = """            static %s_Type %s;
    """

hClosing = """           
        };
    }

    #endif /* %s_%s_H_ */
    """

#=========================================================================
# C++ Source template (.cpp file)
#=========================================================================
cTop = """/*
 * %s.cpp
 *
 * Generated by SILECS framework tools 
 */
 
#include <%s/Common/%s.h>
#include <fesa-core/Synchronization/NoneContext.h>
#include <fesa-core/Synchronization/MultiplexingContext.h>
 
namespace %s
{
    //Global objects of the SILECS class
    Silecs::Service* Abstract%s::pService_ = NULL;
    Silecs::Cluster* Abstract%s::pCluster_ = NULL;
    bool Abstract%s::isInitialized_ = false;

    """

cGlobal = """%s_Type\t%s::%s("%s");
    """
cPart1 = """
    //-------------------------------------------------------------------------------------------------------------
    // Constructor & Destructor methods
    
    Abstract%s::Abstract%s(std::string blockName): blockName_(blockName) {}
    Abstract%s::~Abstract%s() {}
    """

cBlockConstr = """
    %s_Type::%s_Type(std::string name): Abstract%s(name) {}
    %s_Type::~%s_Type() {}
    """

cPart2 = """
    //---------------------------------------------------------------------------------------------------------
    // Set-up the SILECS components for the Abstract%s class (service & cluster)

    void Abstract%s::setup(const ServiceLocator* serviceLocator)
    {
        try
        {
            // Instantiate the singleton of the SILECS Service
            pService_ = Silecs::Service::getInstance();

            // Enable the SILECS diagnostic with user topics if any
            pService_->setArguments(serviceLocator->getUsrCmdArgs());

            // Instantiate the SILECS Cluster object for the given Class/Version
            GlobalDevice* pGlobalDevice = serviceLocator->getGlobalDevice();
            pCluster_ = pService_->getCluster( "%s", pGlobalDevice->plcClassVersion.get());
            isInitialized_ = true;

            // Connect each PLC of the Cluster that is referred from the FESA instance
            std::vector<Device*> pDeviceCol = serviceLocator->getDeviceCollection();
            for(std::vector<Device*>::iterator pDeviceIter=pDeviceCol.begin(); pDeviceIter!= pDeviceCol.end(); pDeviceIter++)
            {
                Device* pDevice = *pDeviceIter;

                // Retrieve the PLC related to the current FESA device
                // (from 'plcHostName' FESA field defined on that purpose).
                Silecs::PLC* pPLC = pCluster_->getPLC(pDevice->plcHostName.get(),pDevice->parameterFile.get());

                // Update the PLC Slave registers from related FESA fields just before synchronising done at connection time
                setPLCSlaveRegisters(pPLC, serviceLocator);

                // Connect the PLC if not already connected
                if (!pPLC->isEnabled())
                {   pPLC->connect(/*synchroMode=*/Silecs::FULL_SYNCHRO, /*connectNow=*/true);
                    if (pPLC->isConnected())
                    {   // Update FESA fields from related PLC Master registers just after synchronising done at connection time
                        getPLCMasterRegisters(pPLC, serviceLocator);
                    }
                }
            }
        }
        catch (const Silecs::SilecsException& ex)
        {
            throw fesa::FesaException(__FILE__, __LINE__, ex.getMessage());
        }
    }

    //---------------------------------------------------------------------------------------------------------
    // Release all the SILECS resources
    void Abstract%s::cleanup()
    {
        // Attention! This method is responsible to stop all the PLC connections
        // and to remove all the SILECS resources (Clusters and related components: PLCs, Devices, Registers, ..)
        // Calling method must ensure that no process is currently accessing these resources before cleaning.
        //
        Silecs::Service::deleteInstance();
    }

    //---------------------------------------------------------------------------------------------------------
    // Synchronise PLC SLAVE/MASTER registers and related FESA fields (automatically called by the setup method @connection time)
    void Abstract%s::setPLCSlaveRegisters(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator)
    {
        fesa::NoneContext noneContext;
    """

cSetPLC = """
        %s::%s.setPLCDevices(pPLC, serviceLocator, false, &noneContext);"""

cPart3 = """
    }

    void Abstract%s::getPLCMasterRegisters(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator)
    {
        fesa::NoneContext noneContext;    //MASTER acquisition fields are not consistent, can be set with none-context
    """

cGetPLC = """
        %s::%s.getPLCDevices(pPLC, serviceLocator, false, &noneContext);"""

cPart4 = """
    }
    
    //---------------------------------------------------------------------------------------------------------
    // General methods to synchronize the FESA fields and related PLC registers of the FESA server
    // with or without PLC side access (send/recv) if requested.
    // get_ : [receive block from PLC +] update FESA fields with related PLC registers
    // set_ : update PLC registers with related FESA fields [+ send block to PLC]

    //---------------------------------------------------------------------------------------------------------

    void Abstract%s::getAllDevices(const ServiceLocator* serviceLocator, const bool recvNow, MultiplexingContext* pContext)
    {
        if (recvNow) theCluster()->recv(blockName_);

        std::vector<Device*> deviceCol = serviceLocator->getDeviceCollection();
        for(std::vector<Device*>::iterator pDeviceIter=deviceCol.begin(); pDeviceIter!= deviceCol.end(); pDeviceIter++)
        {  getOneDevice(*pDeviceIter, false, pContext);
        }
    }

    void Abstract%s::getPLCDevices(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator, const bool recvNow, MultiplexingContext* pContext)
    {
        if (recvNow) pPLC->recv(blockName_);

        std::vector<Device*> deviceCol = serviceLocator->getDeviceCollection();
        for(std::vector<Device*>::iterator pDeviceIter=deviceCol.begin(); pDeviceIter!= deviceCol.end(); pDeviceIter++)
        {   if ((*pDeviceIter)->plcHostName.get() == pPLC->getName())
            {  getOneDevice(*pDeviceIter, false, pContext);
            }
        }
    }

    void Abstract%s::getSomeDevices(std::vector<Device*> deviceCol, const bool sendNow, MultiplexingContext* pContext)
    {
        for(std::vector<Device*>::iterator pDeviceIter=deviceCol.begin(); pDeviceIter!= deviceCol.end(); pDeviceIter++)
        {    getOneDevice(*pDeviceIter, sendNow, pContext);
        }
    }

    void Abstract%s::getOneDevice(Device* pDevice, const bool recvNow, MultiplexingContext* pContext) {};

    //---------------------------------------------------------------------------------------------------------

    void Abstract%s::setAllDevices(const ServiceLocator* serviceLocator, bool sendNow, MultiplexingContext* pContext)
    {
        std::vector<Device*> deviceCol = serviceLocator->getDeviceCollection();
        for(std::vector<Device*>::iterator pDeviceIter=deviceCol.begin(); pDeviceIter!= deviceCol.end(); pDeviceIter++)
        {  setOneDevice(*pDeviceIter, false, pContext);
        }

        if (sendNow) theCluster()->send(blockName_);
    }

    void Abstract%s::setPLCDevices(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator, bool sendNow, MultiplexingContext* pContext)
    {
        std::vector<Device*> deviceCol = serviceLocator->getDeviceCollection();
        for(std::vector<Device*>::iterator pDeviceIter=deviceCol.begin(); pDeviceIter!= deviceCol.end(); pDeviceIter++)
        {   if ((*pDeviceIter)->plcHostName.get() == pPLC->getName())
            {  setOneDevice(*pDeviceIter, false, pContext);
            }
        }

        if (sendNow) pPLC->send(blockName_);
    }

    void Abstract%s::setSomeDevices(std::vector<Device*> deviceCol, bool sendNow, MultiplexingContext* pContext)
    {
        for(std::vector<Device*>::iterator pDeviceIter=deviceCol.begin(); pDeviceIter!= deviceCol.end(); pDeviceIter++)
        {    setOneDevice(*pDeviceIter, sendNow, pContext);
        }
    }

    void Abstract%s::setOneDevice(Device* pDevice, const bool sendNow, MultiplexingContext* pContext) {};
    
    //---------------------------------------------------------------------------------------------------------
    """

cCommonGet = """
    void %s_Type::getOneDevice(Device* pDevice, const bool recvNow, MultiplexingContext* pContext)
    {
    	if( !isInitialized_ )
    	{
    		throw fesa::FesaException(__FILE__, __LINE__, "SILECS-Service not initialized yet - %s::setup needs to be called before any plc-interaction can be done");
    	}
        Silecs::PLC* pPLC  = pCluster_->getPLC(pDevice->plcHostName.get(),pDevice->parameterFile.get());
        Silecs::Device* pPLCDevice = pPLC->getDevice(pDevice->plcDeviceLabel.get());
"""

cRegVar = """        Silecs::Register*  pRegister = NULL;
"""

cGetArrayVar = """        uint32_t dim1 = 1;
"""
cGetArray2DVar = """        uint32_t dim2 = 1;
"""
cSetArrayVar = """        uint32_t dim1 = 1;
        uint32_t fesaDim1;
"""
cSetArray2DVar = """        uint32_t dim2 = 1;
        uint32_t fesaDim2;
"""

cRecv = """        if (recvNow) pPLCDevice -> recv(blockName_);        
    """

cGetStringReg = """
        pRegister = pPLCDevice->getRegister("%s");
        pDevice->%s.set(pRegister->getValString().c_str(), pContext);
"""

cGetStringArrayReg = """
        {
        pRegister = pPLCDevice->getRegister("%s");
        dim1 = pRegister->getDimension1();
        const std::string** stdStringArray = pRegister->getRefStringArray(dim1);
        for (unsigned int i=0; i<dim1; i++)
        {   pDevice->%s.setString(stdStringArray[i]->c_str(), i, pContext);
        }
        }
"""

cGetScalarReg = """
        pDevice->%s.set( pPLCDevice->getRegister("%s")->getVal%s(), pContext);"""

cGetArrayReg = """
        pRegister = pPLCDevice->getRegister("%s");
            dim1 = pRegister->getDimension1();
            pDevice->%s.set(pRegister->getRef%sArray(dim1), dim1, pContext);
        """
cGetArray2DReg = """
        pRegister = pPLCDevice->getRegister("%s");
        dim1 = pRegister->getDimension1();
        dim2 = pRegister->getDimension2();
        pDevice->%s.set(pRegister->getRef%sArray2D(dim1, dim2), dim1, dim2, pContext);
"""
cGetUnsignedArrayReg = """
        pRegister = pPLCDevice->getRegister("%s");
            dim1 = pRegister->getDimension1();
            %s* %s = (%s*)calloc(dim1, sizeof(%s));
            pRegister->getVal%sArray(%s, dim1);\t//use automatic conversion for JAVA non-supported type
            pDevice->%s.set(%s, dim1, pContext);
            free(%s);
    """

cGetUnsignedArray2DReg = """
        pRegister = pPLCDevice->getRegister("%s");
        dim1 = pRegister->getDimension1();
        dim2 = pRegister->getDimension2();
        %s* %s = (%s*)calloc(dim1*dim2, sizeof(%s));
        pRegister->getVal%sArray2D(%s, dim1, dim2);\t//use automatic conversion for JAVA non-supported type
        pDevice->%s.set(%s, dim1, dim2, pContext);
    free(%s);
"""

cCommonSet = """    
    void %s_Type::setOneDevice(Device* pDevice, const bool sendNow, MultiplexingContext* pContext)
    {
    	if( !isInitialized_ )
    	{
    		throw fesa::FesaException(__FILE__, __LINE__, "SILECS-Service not initialized yet - %s::setup needs to be called before any plc-interaction can be done");
    	}
        Silecs::PLC* pPLC  = pCluster_->getPLC(pDevice->plcHostName.get(),pDevice->parameterFile.get());
        Silecs::Device* pPLCDevice = pPLC->getDevice(pDevice->plcDeviceLabel.get());
"""

cSend = """
        if (sendNow) pPLCDevice->send(blockName_);
"""

cDatatypeSet = """
    void %s_Type::setOneDevice(Device* pDevice, %sPropertyData& data, bool sendNow, MultiplexingContext* pContext)
    {
    	if( !isInitialized_ )
    	{
    		throw fesa::FesaException(__FILE__, __LINE__, "SILECS-Service not initialized yet - %s::setup needs to be called before any plc-interaction can be done");
    	}
        Silecs::PLC* pPLC = pCluster_->getPLC(pDevice->plcHostName.get(),pDevice->parameterFile.get());
        Silecs::Device* pPLCDevice = pPLC->getDevice(pDevice->plcDeviceLabel.get());
"""

cSetStringReg = """
        pPLCDevice->getRegister("%s")->setValString(pDevice->%s.get(pContext));
"""

cSetStringArrayReg = """
        {
        pRegister = pPLCDevice->getRegister("%s");
        dim1 = pRegister->getDimension1();
        std::string stdStringArray[dim1];
        const char** cStringArray = pDevice->%s.get(fesaDim1, pContext);
        for (unsigned int i=0; i<dim1; i++) stdStringArray[i] = (const char*)cStringArray[i];
        pRegister->setValStringArray(stdStringArray, dim1);
        }
"""

cSetScalarReg = """
        pPLCDevice->getRegister("%s")->setVal%s( pDevice->%s.get(pContext));"""
            
cSetScalarUReg = """
        pPLCDevice->getRegister("%s")->setVal%s( (%s)pDevice->%s.get(pContext));"""

cSetArrayReg = """
        pRegister = pPLCDevice->getRegister("%s");
            dim1 = pRegister->getDimension1();
            pRegister->setVal%sArray(pDevice->%s.get(fesaDim1, pContext), dim1);
    """

cSetArray2DReg = """
    pRegister = pPLCDevice->getRegister("%s");
        dim1 = pRegister->getDimension1();
        dim2 = pRegister->getDimension2();
        pRegister->setVal%sArray2D(pDevice->%s.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
"""

cSetUnsignedArrayReg = """
        pRegister = pPLCDevice->getRegister("%s");
        dim1 = pRegister->getDimension1();
        pRegister->setVal%sArray(pDevice->%s.get(fesaDim1, pContext), dim1);\t//use automatic conversion for JAVA non-supported type
"""

cSetUnsignedArray2DReg = """
        pRegister = pPLCDevice->getRegister("%s");
        dim1 = pRegister->getDimension1();
        dim2 = pRegister->getDimension2();
        pRegister->setVal%sArray2D( pDevice->%s.get(fesaDim1, fesaDim2, pContext), dim1, dim2);\t//use automatic conversion for JAVA non-supported type
"""

cSetStringRegData = """
        (data.is%sAvailable()) ? pPLCDevice->getRegister("%s")->setValString(data.%s.get()) :
                                     pPLCDevice->getRegister("%s")->setValString(pDevice->%s.get(pContext));"""
                                    
cSetStringArrayRegData = """
        {
        pRegister = pPLCDevice->getRegister("%s");
        dim1 = pRegister->getDimension1();
        std::string stdStringArray[dim1];
        const char** cStringArray = (data.is%sAvailable() ? data.%s.get(fesaDim1) : pDevice->%s.get(fesaDim1, pContext));
        for (unsigned int i=0; i<dim1; i++) stdStringArray[i] = (const char*)cStringArray[i];
        pRegister->setValStringArray(stdStringArray, dim1);
        }
"""
cSetScalarRegData = """
        (data.is%sAvailable()) ? pPLCDevice->getRegister("%s")->setVal%s( data.%s.get()) :
                                          pPLCDevice->getRegister("%s")->setVal%s( pDevice->%s.get(pContext));"""

cSetScalarURegData = """
        (data.is%sAvailable()) ? pPLCDevice->getRegister("%s")->setVal%s( (%s)data.%s.get()) :
                                          pPLCDevice->getRegister("%s")->setVal%s( (%s)pDevice->%s.get(pContext));"""

cSetArrayRegData = """
        pRegister = pPLCDevice->getRegister("%s");
            dim1 = pRegister->getDimension1();
            (data.is%sAvailable()) ? pRegister->setVal%sArray( data.%s.get(fesaDim1), dim1) :
                                         pRegister->setVal%sArray( pDevice->%s.get(fesaDim1, pContext), dim1);
    """

cSetUnsignedArrayRegData = """
        pRegister = pPLCDevice->getRegister("%s");
            dim1 = pRegister->getDimension1();
            (data.is%sAvailable()) ? pRegister->setVal%sArray( data.%s.get(fesaDim1), dim1) :
                                         pRegister->setVal%sArray( pDevice->%s.get(fesaDim1, pContext), dim1);
    """

cSetArray2DRegData = """
        pRegister = pPLCDevice->getRegister("%s");
        dim1 = pRegister->getDimension1();
        dim2 = pRegister->getDimension2();
        (data.is%sAvailable()) ? pRegister->setVal%sArray2D(data.%s.get(fesaDim1, fesaDim2), dim1, dim2) :
                                     pRegister->setVal%sArray2D(pDevice->%s.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
"""

cSetUnsignedArray2DRegData = """
        pRegister = pPLCDevice->getRegister("%s");
        dim1 = pRegister->getDimension1();
        dim2 = pRegister->getDimension2();
        (data.is%sAvailable()) ? pRegister->setVal%sArray2D(data.%s.get(fesaDim1, fesaDim2), dim1, dim2) :
                                     pRegister->setVal%sArray2D(pDevice->%s.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
"""

makeDesign = """# Include SILECS library path
SILECS_PATH ?= %s

# Additional compiler warning flags
override WARNFLAGS += 

# Additional compiler flags
COMPILER_FLAGS += -I$(SILECS_PATH)/include -I$(SILECS_PATH)/include/silecs-communication/interface/core
COMPILER_FLAGS +=
LINKER_FLAGS +=

# Additional headers (Custom.h Specific.h ...) which need to be installed
EXTRA_HEADERS += 

    """

makeDeploy = """# Include SILECS library path
SILECS_PATH ?= %s

SNAP7_BASE = %s

# Additional compiler warning flags
override WARNFLAGS += 

# Additional libs and flags which are common to the Realtime and Server part
COMPILER_FLAGS +=
LINKER_FLAGS += -L$(SILECS_PATH)/lib/$(CPU) -lsilecs-comm
LINKER_FLAGS += -L$(SNAP7_BASE)/bin/$(CPU)-linux -lsnap7
#add default search path for dynamic snap7 library
LINKER_FLAGS += -Wl,-rpath,$(SNAP7_BASE)/bin/$(CPU)-linux,-rpath,/usr/lib
LINKER_FLAGS +=

# Additional libs and flags which are specific to the Realtime part
COMPILER_RT_FLAGS += 
LINKER_RT_FLAGS += 

# Additional libs and flags which are specific to the Server part
COMPILER_SERVER_FLAGS += 
LINKER_SERVER_FLAGS += 

# Additional headers (Custom.h Specific.h ...) which need to be released
EXTRA_HEADERS += 

    """

#=========================================================================
# FESA .cproject file
#=========================================================================

def genCProject():
    return cproject

#=========================================================================
# Header file (.h) code generation sub-functions
#=========================================================================
def genHTop(className):
    return hTop %(className, className, className, className, className, className)

def genHTopBlock(className, blockName):
    return hTopBlock %(className, blockName)

def genHTop2(className):
    return hTop2 %(className, className, className, className, className, className, className, className, className, className, className)

def genHBlock(mode, blockName):
    return hBlock %(mode, blockName)

def genHBottom(className):
    return hBottom %(className, className, className, className, className)

def genHDeclBlocks(className): 
    return hDeclBlocks %(className, className)

def genHClosing(className):
    return hClosing %(className, className)

#=========================================================================
# C++ file (.cpp) code generation sub-functions
#=========================================================================
def genCTop(className):
    return cTop %(className, className, className, className, className, className, className)

def genCGlobal(className, blockName):
    return cGlobal %(blockName, className, blockName, blockName)

def genCPart1(className):
    return cPart1 %(className, className, className, className)

def genCBlockConstr(blockName, className):
    return cBlockConstr %(blockName, blockName, className, blockName, blockName)

def genCPart2(className):
    return cPart2 %(className, className, className, className, className)

def genCSetPLC(className, blockName):
    return cSetPLC %(className, blockName)

def genCCommonGet(blockName,className):
    return cCommonGet %(blockName,className)

def genCPart3(className):
    return cPart3 %(className)

def genCGetPLC(className, blockName):
    return cGetPLC %(className, blockName)

def genCPart4(className):
    return cPart4 %(className, className, className, className, className, className, className, className)

def genCGetStringReg(regName):
    return cGetStringReg %(regName, regName)

def genCGetStringArrayReg(regName):
    return cGetStringArrayReg %(regName, regName)

def genCGetScalarReg(regName, regType):
    return cGetScalarReg %(regName, regName, regType)

def genCGetArrayReg(regName, regType):    
    return cGetArrayReg %(regName, regName, regType)

def genCGetArray2DReg(regName, regType):
    return cGetArray2DReg %(regName, regName, regType)

def genCGetUnsignedArrayReg(regName, fesaType, regType):
    return cGetUnsignedArrayReg %(regName, fesaType, regName, fesaType, fesaType, regType, regName, regName, regName, regName)

def genCGetUnsignedArray2DReg(regName, fesaType, regType):
    return cGetUnsignedArray2DReg %(regName, fesaType, regName, fesaType, fesaType, regType, regName, regName, regName, regName)

def genCCommonSet(blockName,className):
    return cCommonSet %(blockName,className)

def genCDatatypeSet(blockName,className):
    return cDatatypeSet %(blockName, blockName,className)

def genCSetStringReg(regName):
    return cSetStringReg %(regName, regName)

def genCSetStringArrayReg(regName):
    return cSetStringArrayReg %(regName, regName)

def genCSetScalarReg(regName, regType):
    return cSetScalarReg %(regName, regType, regName) 

def genCSetScalarUReg(regName, regType, lowerType):
    return cSetScalarUReg %(regName, regType, lowerType, regName)

def genCSetArrayReg(regName, regType):
    return cSetArrayReg %(regName, regType, regName)

def genCSetUnsignedArrayReg(regName, regType):    
    return cSetUnsignedArrayReg %(regName, regType, regName)

def genCSetArray2DReg(regName, regType):
    return cSetArray2DReg %(regName, regType, regName)

def genCSetUnsignedArray2DReg(regName, regType):
    return cSetUnsignedArray2DReg %(regName, regType, regName)

def genCSetStringRegData(regName):
    return cSetStringRegData %(iecommon.capitalizeString(regName), regName, regName, regName, regName)

def genCSetStringArrayRegData(regName):
    return cSetStringArrayRegData %(regName, iecommon.capitalizeString(regName), regName, regName)

def genCSetScalarRegData(regName, regType):
    return cSetScalarRegData %(iecommon.capitalizeString(regName), regName, regType, regName, regName, regType, regName)

def genCSetScalarURegData(regName, regType, lowerType):
    return cSetScalarURegData %(iecommon.capitalizeString(regName), regName, regType, lowerType, regName, regName, regType, lowerType, regName)

def genCSetUnsignedArrayRegData(regName, regType):
    return cSetUnsignedArrayRegData %(regName, iecommon.capitalizeString(regName), regType, regName, regType, regName) 

def genCSetUnsignedArray2DRegData(regName, fesaType, regType):
    return cSetUnsignedArray2DRegData %(regName, iecommon.capitalizeString(regName), regType, regName, regType, regName)  

def genCSetArrayRegData(regName, regType):
    return cSetArrayRegData %(regName, iecommon.capitalizeString(regName), regType, regName, regType, regName)

def genCSetArray2DRegData(regName, fesaType, regType):
    return cSetArray2DRegData %(regName, iecommon.capitalizeString(regName), regType, regName, regType, regName)

def genMakeDesign(CentralMakefilePath):
    return makeDesign %(CentralMakefilePath)

def genMakeDeploy(silecsBasePath,snap7BasePath):
    return makeDeploy %(silecsBasePath,snap7BasePath)
