// Copyright 2016 CERN and GSI
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <silecs-diagnostic/loginhandler.h>

#ifdef WITH_RBAC
    extern std::string UserName;

    loginHandler::loginHandler()
    {
    }

    bool loginHandler::requestLogin()
    {
        LoginDialog *loginDialog = new LoginDialog();

        for(int i=0;i<NUMBER_PASSWORD_ATTEMPTS;i++)
        {
            try
            {
                //Popup interface requesting password

                loginDialog->setModal(true);

                if(loginDialog->exec()==1)
                {
                    auto_ptr<cmw::rbac::TokenClass> token = cmw::rbac::LoginContext::login("SILECS Diagnostic Tool",
                                                                                           loginDialog->getUsername(),
                                                                                           loginDialog->getPassword());
                    if (token.get() != NULL)
                    {
                        //password correct
                        extern std::string UserName;
                        UserName = loginDialog->getUsername();
                        delete loginDialog;
                        return true;
                    }
                }
                else
                {
                    //cancell button was pressed
                    delete loginDialog;
                    return false;
                }
            }
            catch (const cmw::rbac::AuthenticationFailure & ex)
            {
                qDebug() << "Autentication failure!";
            }
            catch(...)
            {
                qDebug() << "unknown exception";
            }
        }

        delete loginDialog;
        return false;
    }
#endif
