// Copyright 2016 CERN and GSI
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef SILECS_DIAG_LOGINHANDLER_H
#define SILECS_DIAG_LOGINHANDLER_H

#include <QtGui>
#include <QtCore>

#include <silecs-diagnostic/logindialog.h>
#include <silecs-diagnostic/constants.h>

#include <iostream>

#ifdef WITH_RBAC
    #include <cmw-rbac/LoginContext.h>
    #include <cmw-rbac/AuthenticationFailure.h>
#endif

using namespace std;

#ifdef WITH_RBAC
    extern std::string USER_NAME;

    class loginHandler
    {
    public:
        loginHandler();
        bool requestLogin();
    };
#endif


#endif // SILECS_DIAG_LOGINHANDLER_H
